## sortmerna 4.3.7

=== CMakeLists.txt ===
﻿#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 06, 2017
#
# Top level CMake file for sortmerna
#===============================================================================

cmake_minimum_required(VERSION 3.21)
project(sortmerna CXX C)
set(CMAKE_CXX_STANDARD 17)

find_package(Git)
string(TIMESTAMP GIT_DATE_TIME "%Y/%m/%d %H:%M:%S" UTC)

#
# Prepare Version information
#
if(GIT_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  if(WIN32)
    execute_process(COMMAND $ENV{COMSPEC} /C ${GIT_EXECUTABLE} -C ${CMAKE_CURRENT_SOURCE_DIR} rev-parse HEAD OUTPUT_VARIABLE GIT_SHA)
  else()
    execute_process(COMMAND ${GIT_EXECUTABLE} -C ${CMAKE_CURRENT_SOURCE_DIR} rev-parse HEAD OUTPUT_VARIABLE GIT_SHA)
  endif()
else()
  set(GIT_SHA 0)
endif()

string(REGEX REPLACE "[^0-9a-f]+" "" GIT_SHA "${GIT_SHA}")

# Read sortmerna version from version.h file.
set(VERSION_FILE include/version.h)
message("parsing version file: ${VERSION_FILE}")
file(READ ${VERSION_FILE} version_header_file)
string(REGEX MATCH "#define SORTMERNA_MAJOR ([0-9]+)" _ ${version_header_file})
set(SORTMERNA_VERSION_MAJOR ${CMAKE_MATCH_1})
string(REGEX MATCH "#define SORTMERNA_MINOR ([0-9]+)" _ ${version_header_file})
set(SORTMERNA_VERSION_MINOR ${CMAKE_MATCH_1})
string(REGEX MATCH "#define SORTMERNA_PATCH ([0-9]+)" _ ${version_header_file})
set(SORTMERNA_VERSION_PATCH ${CMAKE_MATCH_1})
set(SORTMERNA_VERSION ${SORTMERNA_VERSION_MAJOR}.${SORTMERNA_VERSION_MINOR}.${SORTMERNA_VERSION_PATCH})

message("PROJECT_BINARY_DIR = ${PROJECT_BINARY_DIR}")
message("CMAKE_CXX_COMPILER_ID = ${CMAKE_CXX_COMPILER_ID}") # 'GNU' on Ubuntu
message("CMAKE_CONFIGURATION_TYPES = ${CMAKE_CONFIGURATION_TYPES}")
message("CMAKE_HOST_SYSTEM_NAME = ${CMAKE_HOST_SYSTEM_NAME}")
message("CMAKE_HOST_SYSTEM_VERSION = ${CMAKE_HOST_SYSTEM_VERSION}")
message("CMAKE_HOST_SYSTEM = ${CMAKE_HOST_SYSTEM}")
message("CMAKE_BINARY_DIR = ${CMAKE_BINARY_DIR}")
message("CMAKE_CURRENT_BINARY_DIR = ${CMAKE_CURRENT_BINARY_DIR}")
message("RUNTIME_OUTPUT_DIRECTORY_RELEASE = ${RUNTIME_OUTPUT_DIRECTORY_RELEASE}")
message("CMAKE_CXX_FLAGS_DEBUG: ${CMAKE_CXX_FLAGS_DEBUG}")
message("CMAKE_C_FLAGS_DEBUG: ${CMAKE_C_FLAGS_DEBUG}")

set(EXTERNAL_DEPS ${CMAKE_SOURCE_DIR}/3rdparty CACHE PATH "Installation directory for 3rd party dependencies")
set(DIRENTWIN_URL https://github.com/tronkko/dirent CACHE STRING "Dirent-Windows interface GitHub URL")
set(DIRENTWIN_HOME ${EXTERNAL_DEPS}/dirent CACHE PATH "Dirent-Windows interface installation directory")

option(WITH_TESTS "Select whether to build tests" OFF)

if("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND "${EXTRA_CXX_FLAGS_RELEASE}" STRGREATER "")
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${EXTRA_CXX_FLAGS_RELEASE}")
		set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${EXTRA_C_FLAGS_RELEASE}")
	endif()
endif()

message("CMAKE_CXX_FLAGS_RELEASE: ${CMAKE_CXX_FLAGS_RELEASE}")
message("EXTRA_CXX_FLAGS_RELEASE: ${EXTRA_CXX_FLAGS_RELEASE}")

# download dirent. Only dirent.h used from this project - no need to build
if(WIN32 AND NOT EXISTS ${DIRENTWIN_HOME})
	execute_process(COMMAND git clone --depth 1 ${DIRENTWIN_URL}
		WORKING_DIRECTORY ${EXTERNAL_DEPS}
)
endif()

# build build_version
set(BUILD_VERSION_CPP ${CMAKE_BINARY_DIR}/build_version.cpp)
configure_file(src/util/build_version.cpp.in ${BUILD_VERSION_CPP} @ONLY)
add_library(build_version OBJECT ${BUILD_VERSION_CPP})
target_include_directories(build_version PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)

## build cmph
add_subdirectory(${EXTERNAL_DEPS}/cmph)

## build alp
add_subdirectory(${EXTERNAL_DEPS}/alp)

## build winapi
if(WIN32)
	add_subdirectory(${CMAKE_SOURCE_DIR}/src/winapi)
endif()

## build sortmerna
add_subdirectory(${CMAKE_SOURCE_DIR}/src/sortmerna)

if (WITH_TESTS)
  add_subdirectory (tests/sortmerna)
endif ()

include(CMakePackageConfigHelpers)

set(package_config_destination ${CMAKE_INSTALL_PREFIX}/cmake/sortmerna)
message("package_config_destination: ${package_config_destination}")

configure_package_config_file(
	${CMAKE_SOURCE_DIR}/cmake/sortmernaConfig.cmake.in sortmernaConfig.cmake
	INSTALL_DESTINATION ${package_config_destination}
)

write_basic_package_version_file(
	sortmernaConfigVersion.cmake
	VERSION ${SORTMERNA_VERSION}
	COMPATIBILITY SameMajorVersion
)  

install(TARGETS sortmerna
	EXPORT sortmernaTargets
	RUNTIME 
	DESTINATION bin
	COMPONENT runtime
)

install(FILES
		${CMAKE_CURRENT_BINARY_DIR}/sortmernaConfig.cmake
		${CMAKE_CURRENT_BINARY_DIR}/sortmernaConfigVersion.cmake
	DESTINATION ${package_config_destination}
	COMPONENT config
)

# generate PACKAGE and PACKAGE_SOURCE targets, and CPack configuration files
# to build distribution archive/installer
set(CPACK_PACKAGE_VENDOR "Clarity Genomics")
set(CPACK_PACKAGE_DIRECTORY ${CMAKE_INSTALL_PREFIX})
set(CPACK_PACKAGE_VERSION_MAJOR ${SORTMERNA_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${SORTMERNA_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${SORTMERNA_VERSION_PATCH})
if(UNIX AND NOT APPLE) # CMAKE_HOST_SYSTEM_NAME = Linux
	set(CPACK_GENERATOR "DEB" "STGZ" "TGZ") # "TGZ" - use for Conda build to pick-up
	set(CPACK_DEBIAN_PACKAGE_DEBUG ON) # output Deb generator trace debug information
	#set(CPACK_DEB_COMPONENT_INSTALL ON) # Enable component packaging for CPackDEB
	if(NOT PORTABLE)
		set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
	endif()
	set(CPACK_DEBIAN_PACKAGE_MAINTAINER "biocodz")
endif()
include(CPack)

=== 3rdparty/alp/CMakeLists.txt ===
#===============================================================================
# file: CMakeLists.txt
# created: Jun 10, 2017
#
# CMake file for sortmerna/3rdparty/alp
#===============================================================================

cmake_minimum_required(VERSION 3.21)
project(alp CXX)

set(CMAKE_CXX_STANDARD 11)

set(ALP_HDRS
	njn_approx.hpp
	njn_doubletype.hpp
	njn_dynprogprob.hpp
	njn_dynprogproblim.hpp
	njn_dynprogprobproto.hpp
	njn_function.hpp
	njn_integer.hpp
	njn_ioutil.hpp
	njn_localmaxstat.hpp
	njn_localmaxstatmatrix.hpp
	njn_localmaxstatutil.hpp
	njn_matrix.hpp
	njn_memutil.hpp
	njn_random.hpp
	njn_root.hpp
	njn_uniform.hpp
	njn_vector.hpp
	sls_alignment_evaluer.hpp
	sls_alp.hpp
	sls_alp_data.hpp
	sls_alp_regression.hpp
	sls_alp_sim.hpp
	sls_basic.hpp
	sls_normal_distr_array.hpp
	sls_pvalues.hpp
)

set (ALP_SRCS
	njn_dynprogprob.cpp
	njn_dynprogproblim.cpp
	njn_dynprogprobproto.cpp
	njn_ioutil.cpp
	njn_localmaxstat.cpp
	njn_localmaxstatmatrix.cpp
	njn_localmaxstatutil.cpp
	njn_random.cpp
	sls_alignment_evaluer.cpp
	sls_alp.cpp
	sls_alp_data.cpp
	sls_alp_regression.cpp
	sls_alp_sim.cpp
	sls_basic.cpp
	sls_pvalues.cpp
)


add_Library(alp OBJECT ${ALP_HDRS} ${ALP_SRCS})
target_include_directories(alp PUBLIC ${CMAKE_SOURCE_DIR}/3rdparty/alp)

#add_Library(alp INTERFACE)
#target_sources(alp INTERFACE ${ALP_HDRS})

=== 3rdparty/cmph/CMakeLists.txt ===
#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 08, 2017
#
# CMake file for sortmerna/cmph
#===============================================================================

cmake_minimum_required(VERSION 3.21)
project(cmph CXX)

#AUX_SOURCE_DIRECTORY(${CMAKE_SOURCE_DIR}/cmph CMPH_SRCS)
#include_directories(${CMAKE_SOURCE_DIR}/cmph)              # not recommended practice. 
#file(GLOB CMPH_HDRS ${CMAKE_SOURCE_DIR}/cmph "*.h" )       # not recommended practice. List files explicitly

# find sortmerna/cmph -name '*.h' -printf "%f\n"
set(CMPH_HDRS
    bdz.h
	bdz_ph.h
	bdz_structs.h
	bdz_structs_ph.h
	bitbool.h
	bmz.h
	bmz8.h
	bmz8_structs.h
	bmz_structs.h
	brz.h
	brz_structs.h
	buffer_entry.h
	buffer_manager.h
	chd.h
	chd_ph.h
	chd_structs.h
	chd_structs_ph.h
	chm.h
	chm_structs.h
	cmph.h
	cmph_structs.h
	cmph_time.h
	cmph_types.h
	compressed_rank.h
	compressed_seq.h
	debug.h
	fch.h
	fch_buckets.h
	fch_structs.h
	graph.h
	hash.h
	hash_state.h
	jenkins_hash.h
	miller_rabin.h
	select.h
	select_lookup_tables.h
	vqueue.h
	vstack.h
)

# find sortmerna/cmph -name '*.c' -printf "%f\n"
set(CMPH_SRCS
	bdz.c
	bdz_ph.c
	bmz.c
	bmz8.c
	brz.c
	buffer_entry.c
	buffer_manager.c
	chd.c
	chd_ph.c
	chm.c
	cmph.c
	cmph_structs.c
	compressed_rank.c
	compressed_seq.c
	fch.c
	fch_buckets.c
	graph.c
	hash.c
	jenkins_hash.c
	miller_rabin.c
	select.c
	vqueue.c
	vstack.c
)

#message("CMPH_SRCS= ${CMPH_SRCS}\nCMPH_PRIVATE_HDRS= ${CMPH_PRIVATE_HDRS}")

add_library(cmph OBJECT ${CMPH_SRCS} ${CMPH_HDRS})
target_include_directories(cmph PUBLIC ${CMAKE_SOURCE_DIR}/3rdparty/cmph)

=== src/sortmerna/CMakeLists.txt ===
#===============================================================================
# file: CMakeLists.txt
# created: Jun 08, 2017
#
# CMake file for sortmerna/src/sortmerna
#===============================================================================

cmake_minimum_required(VERSION 3.21)
project(sortmerna CXX)
set(CMAKE_CXX_STANDARD 17)

find_package(Threads REQUIRED)

include(FindZLIB)
if (DEFINED CACHE{ZLIB_ROOT})
	message("searching ZLIB in ${ZLIB_ROOT}")
else()
	message("searching ZLIB in default locations")
endif()
find_package(ZLIB MODULE REQUIRED) # prevent CONFIG search mode

if(ZLIB_FOUND)
	get_target_property(lib ZLIB::ZLIB LOCATION)
	message("ZLIB::ZLIB LOCATION: ${lib}")
	get_target_property(lib ZLIB::ZLIB LOCATION_DEBUG)
	message("ZLIB::ZLIB LOCATION_DEBUG: ${lib}")
endif(ZLIB_FOUND)

# cmake has no FindRocksDB module, but RocksDB build provides cmake config,
# whence using CONFIG search.
# defines RocksDB::rocksdb (static) and RocksDB::rocksdb-shared targets. Note that
# these names can only be found by reading the package configuration files.
if (DEFINED CACHE{ROCKSDB_DIST})
	find_package(RocksDB CONFIG REQUIRED
	  PATHS ${ROCKSDB_DIST}
	  NO_DEFAULT_PATH
	)
else()
	message("searching RocksDB in default locations")
	list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
	message("CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")
  	find_package(RocksDB REQUIRED)
endif()

if(RocksDB_FOUND)
	message("RocksDB found")
	if(ROCKSDB_USE_STATIC_LIBS)
		message("Using Static RocksDB lib")
		get_target_property(lib RocksDB::rocksdb LOCATION)
		message("RocksDB::rocksdb LOCATION: ${lib}")
		get_target_property(lib RocksDB::rocksdb LOCATION_DEBUG)
		message("RocksDB::rocksdb LOCATION_DEBUG: ${lib}")
		# use ROCKSDB_LIB variable for potential switching between rocksdb and rocksb-shared
		set(ROCKSDB_LIB RocksDB::rocksdb)
	else()
		message("Using Shared RocksDB lib")
		get_target_property(lib RocksDB::rocksdb-shared LOCATION)
		message("RocksDB::rocksdb-shared LOCATION: ${lib}")
		get_target_property(lib RocksDB::rocksdb-shared LOCATION_DEBUG)
		message("RocksDB::rocksdb-shared LOCATION_DEBUG: ${lib}")
	    set(ROCKSDB_LIB RocksDB::rocksdb-shared)
	endif()
	get_property(trans_deps TARGET ${ROCKSDB_LIB} PROPERTY INTERFACE_LINK_LIBRARIES)
	message("${ROCKSDB_LIB} transitive link dependencies: ${trans_deps}")
else()
	message("RocksDB not found")
endif(RocksDB_FOUND)

# fix RocksDBTargets.cmake, which makes both static and shared libraries always dependent on libz.so
if(NOT WIN32)
	if(ZLIB_LIBRARY_RELEASE)
		# modify the dependent libraries of the RocksDB::rocksdb target
		set_target_properties(RocksDB::rocksdb PROPERTIES
			INTERFACE_LINK_LIBRARIES "${ZLIB_LIBRARY_RELEASE};Threads::Threads"
		)
	endif()
endif()

if(RocksDB_FOUND)
get_property(trans_deps TARGET RocksDB::rocksdb PROPERTY INTERFACE_LINK_LIBRARIES)
message("rocksdb transitive link dependencies AFTER modification: ${trans_deps}")
endif(RocksDB_FOUND)
#include(FindRapidJson)
 # prevent CONFIG search mode
#find_package(RapidJson MODULE REQUIRED)

# set additional compile flags
if(MSVC)
#  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zi /nologo /EHsc /GS /Gd /GR /GF /fp:precise /Zc:wchar_t /Zc:forScope /errorReport:queue")
#  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /FC /d2Zi+ /W4 /wd4127 /wd4800 /wd4996 /wd4351 /wd4100 /wd4204 /wd4324")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wextra -Wall -Xlinker -v") # -Xlinker -v / --verbose (linked libraries info)   '-Wl,-Map,mapfile.txt'  '-Wl,-v'
  #set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -v -da -Q") # for segfault
  #                                                    |  |   |_show which function is causing the crash.
  #                                                    |  |_dumps the RTL to a file after each stage
  #                                                    |_show how the program was invoked
  #set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -v -da -Q -O0") # for segfault
#  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsign-compare -Wshadow -Wno-unused-parameter -Wno-unused-variable -Woverloaded-virtual -Wnon-virtual-dtor -Wno-missing-field-initializers -Wno-strict-aliasing")
endif()

#set(MY_OPTS -g -Wall) # using quotes "-g -Wall" throws error
#target_compile_options(smr_objs PUBLIC ${MY_OPTS})
#target_compile_options(smr_objs PUBLIC "$<$<CONFIG:DEBUG>:${MY_OPTS}>")
#target_compile_options(smr_objs PUBLIC "$<$<CONFIG:RELEASE>:${MY_OPTS}>")
#set_target_properties(smr_objs PROPERTIES COMPILE_OPTIONS ${MY_OPTS})

set(SMR_SRCS
	alignment.cpp
	bitvector.cpp
	#callbacks.cpp
	cmd.cpp
	izlib.cpp
	index.cpp
	indexdb.cpp
	kseq_load.cpp
	kvdb.cpp
	options.cpp
	output.cpp
	summary.cpp
	paralleltraversal.cpp
	processor.cpp
	read.cpp
	#read_control.cpp
	readfeed.cpp
	readstats.cpp
	references.cpp
	refstats.cpp
	ssw.c
	traverse_bursttrie.cpp
	util.cpp
	otumap.cpp
	report.cpp
	report_fx_base.cpp
	report_fastx.cpp
	report_fx_other.cpp
	report_blast.cpp
	report_denovo.cpp
	report_biom.cpp
	report_sam.cpp
	#writer.cpp
)

# SMR Objects - build a separate library to use with Tests
add_library(smr_objs OBJECT ${SMR_SRCS})
target_link_libraries(smr_objs
	PUBLIC
		alp
		${ROCKSDB_LIB}
		ZLIB::ZLIB
		#RapidJSON::RapidJSON
)
if(WIN32)
	target_include_directories(smr_objs 
		PUBLIC
			${CMAKE_SOURCE_DIR}/include
			$<TARGET_PROPERTY:winapi,INCLUDE_DIRECTORIES>
			$<TARGET_PROPERTY:cmph,INCLUDE_DIRECTORIES>
			${DIRENTWIN_HOME}/include
			${CONCURRENTQUEUE_HOME}
	)
else()
	target_include_directories(smr_objs 
		PUBLIC
			${CMAKE_SOURCE_DIR}/include
			$<TARGET_PROPERTY:cmph,INCLUDE_DIRECTORIES>
			${CONCURRENTQUEUE_HOME}
	)
endif()

get_property(trans_deps TARGET smr_objs PROPERTY INTERFACE_LINK_LIBRARIES)
message("SMR Objects transitive link dependencies: ${trans_deps}")

get_target_property(COMPILE_OPT smr_objs COMPILE_OPTIONS)
get_target_property(COMPILE_FLG smr_objs COMPILE_FLAGS)
message("SMR Objects COMPILE_OPT: ${COMPILE_OPT}  COMPILE_FLG: ${COMPILE_FLG}")

# SMR
add_executable(sortmerna main.cpp)
if(WIN32)
	target_include_directories(sortmerna 
		PRIVATE
			${CMAKE_SOURCE_DIR}/include
			${DIRENTWIN_HOME}/include
			${CONCURRENTQUEUE_HOME}
	)
	target_link_libraries(sortmerna
		build_version
		smr_objs
		winapi
		alp
		$<TARGET_OBJECTS:cmph>
		ZLIB::ZLIB
		${ROCKSDB_LIB}
		#RapidJSON::RapidJSON
		Rpcrt4.lib
		Cabinet.lib # rocksdb:XPRESS::CreateCompressor,Compress,CloseCompressor,CreateDecompressor,Decompress,CloseDecompressor
	)
else()
	target_include_directories(sortmerna 
		PRIVATE
			${CONCURRENTQUEUE_HOME}
			${CMAKE_SOURCE_DIR}/include
	)
	#get_property(rocksdb_trans_deps TARGET RocksDB::rocksdb PROPERTY INTERFACE_LINK_LIBRARIES)
	#message("rocksdb_trans_deps: ${rocksdb_trans_deps}")
	target_link_libraries(sortmerna
		build_version
		smr_objs
		alp # this is a transitive dependency of smr_objs but the linking fails without it. Why?
		$<TARGET_OBJECTS:cmph>
		${ROCKSDB_LIB}
		${CMAKE_DL_LIBS}
		# the following are all transitive dependencies of smr_objs i.e. no need to link: 
		# RapidJSON::RapidJSON ZLIB::ZLIB Threads::Threads (rockdb deps)
	)
	
	if(PORTABLE)
		target_link_options(sortmerna PRIVATE -static)
	endif(PORTABLE)
endif()

=== src/winapi/CMakeLists.txt ===
#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 10, 2017
#
# CMake file for sortmerna/src/winapi
#===============================================================================

cmake_minimum_required(VERSION 3.21)
project(winapi CXX)

set(WINAPI_HDRS
	include/unistd.h
	include/sys/time.h
)

#add_subdirectory(${CMAKE_SOURCE_DIR}/winapi)

set(WINAPI_SRCS
	unistd.cpp
	wintime.cpp
)

#message("${WINAPI_SRCS}")

add_library(winapi OBJECT ${WINAPI_SRCS} ${WINAPI_HDRS})

source_group(sys FILES ${CMAKE_SOURCE_DIR}/src/winapi/include/sys/time.h) # Not working: "Header Files\\sys" "include\\sys" "sys"

target_include_directories(winapi PUBLIC ${CMAKE_SOURCE_DIR}/src/winapi/include)

=== tests/sortmerna/CMakeLists.txt ===
#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 06, 2018 Wed
#===============================================================================

cmake_minimum_required(VERSION 3.21)
project(tests CXX)

set(CMAKE_CXX_STANDARD 17)

message("tests PROJECT_NAME = ${PROJECT_NAME}")
message("tests PROJECT_BINARY_DIR = ${PROJECT_BINARY_DIR}")
message("tests CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
message("tests CMAKE_CFG_INTDIR = ${CMAKE_CFG_INTDIR}")

set(TEST_SRCS
	kvdb.cpp
	main.cpp
)

add_executable(tests ${TEST_SRCS})
#target_include_directories(tests
#PRIVATE
#		${CMAKE_SOURCE_DIR}/include
#		#${CMAKE_SOURCE_DIR}/src/winapi/include
#)
if(WIN32)
	target_link_libraries(tests
		build_version
		alp
		smr_objs
		winapi
		$<TARGET_OBJECTS:cmph>
	)
else()
	target_link_libraries(tests
		build_version
		alp
		smr_objs
		$<TARGET_OBJECTS:cmph>
	)
endif()

#add_executable("test_${test}" ${test}.cpp $<TARGET_OBJECTS:smr_objs>)

=== debian/changelog ===
sortmerna (4.3.7-3) unstable; urgency=medium

  * c23.patch: new: fix build failure with bool redefinition. (Closes: #1097910)
  * d/watch: port to v5 Github template.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * concurrentqueue.h.patch: normalize Last-Update.
  * d/copyright: point to the versioned LGPL-3.

 -- Étienne Mollier <emollier@debian.org>  Sun, 05 Oct 2025 23:01:51 +0200

sortmerna (4.3.7-2) unstable; urgency=medium

  * Fix Python3.12 string syntax
    Closes: #1087092
  * d/copyright: Fixes thanks to lrc

 -- Andreas Tille <tille@debian.org>  Wed, 11 Dec 2024 17:38:13 +0100

sortmerna (4.3.7-1) unstable; urgency=medium

  * New upstream version 4.3.7
  * cmake_RocksDB.patch: delete: patch now irrelevant.
  * rapidjson.patch: delete: patch now irrelevant.
  * no_static_linking.patch: delete: affected hunk disappeared upstream.
  * typos.patch: delete: affected hunks disappeared upstream.
  * d/{control,rules}: migrate to pybuild and dh-sequence-python3.
  * d/tests/: bring back superficial verifications.
    The way of using sortmerna changed over time, but the test suite
    proposed for autopkgtest needs involved adjustments.  Most of the
    meat of the script is currently skipped, to only verify version and
    usage information can be shown to end users.  Not ideal, but better
    than no tests at all.
  * d/{watch,u/metadata}: adjust to github redirection.
  * d/control: point the homepage to the github project.
    The original homepage on Université de Lille website does not look to
    be available anymore.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Sat, 01 Jun 2024 14:27:59 +0200

sortmerna (4.3.6-3) unstable; urgency=medium

  * d/rules: convert example files to Unicode per lintian flag.
  * typos.patch: add; fix typos caught by lintian.
  * d/copyright: update copyright year.
  * concurrentqueue.h.patch: update concurrentqueue.h location.
    (Closes: #1051325)
  * gcc-13.patch: new: fix ftbfs with gcc-13.

 -- Étienne Mollier <emollier@debian.org>  Wed, 06 Sep 2023 19:43:10 +0200

=== debian/control ===
Source: sortmerna
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               python3-all,
               cmake,
               librocksdb-dev (>= 6.25.3),
               libgflags-dev,
               libsnappy-dev,
               libzstd-dev,
               rapidjson-dev,
               libconcurrentqueue-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/sortmerna
Vcs-Git: https://salsa.debian.org/med-team/sortmerna.git
Homepage: https://github.com/sortmerna/sortmerna

Package: sortmerna
Architecture: any-amd64 any-i386 x32
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         sse2-support [any-i386]
Description: tool for filtering, mapping and OTU-picking NGS reads
 SortMeRNA is a biological sequence analysis tool for filtering, mapping and
 OTU-picking NGS reads. The core algorithm is based on approximate seeds and
 allows for fast and sensitive analyses of nucleotide sequences. The main
 application of SortMeRNA is filtering rRNA from metatranscriptomic data.
 Additional applications include OTU-picking and taxonomy assignation available
 through QIIME v1.9+ (http://qiime.org - v1.9.0-rc1).
 SortMeRNA takes as input a file of reads (fasta or fastq format) and one or
 multiple rRNA database file(s), and sorts apart rRNA and rejected reads into
 two files specified by the user. Optionally, it can provide high quality local
 alignments of rRNA reads against the rRNA database. SortMeRNA works with
 Illumina, 454, Ion Torrent and PacBio data, and can produce SAM and
 BLAST-like alignments.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export CMAKE_PREFIX_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/
DTMP=$(CURDIR)/debian/sortmerna

# In this particular instance, building with sse2 support is not an
# architecture baseline violation for the i386 release architecture, because
# the package is supposed to depend on sse2-support.
ifeq ($(DEB_HOST_ARCH),i386)
export DEB_CFLAGS_MAINT_APPEND+=-msse2
export DEB_CXXFLAGS_MAINT_APPEND+=-msse2
endif

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_install:
	find debian -name cmake -type d | xargs rm -rvf

execute_after_dh_installexamples:
	# Convert example files to Unicode.
	set -e \
	; cd $(CURDIR)/tests/sortmerna/ \
	; for cxxfile in *.cpp \
	; do iconv -f ISO-8859-15 -t UTF-8 \
	     < $${cxxfile} \
	     > $(DTMP)/usr/share/doc/sortmerna/examples/$${cxxfile} \
	; done

execute_after_dh_fixperms:
	find debian/sortmerna -name '*.sh' -exec chmod -v +x '{}' ';'
	find debian/sortmerna -name '*.py' -exec chmod -v -x '{}' ';'

=== debian/watch ===
Version: 5

Template: Github
Owner: sortmerna
Project: sortmerna
UVersion-Mangle: s/-beta/~beta/
